HDU1950 Bridging signals(LIS)

题目链接

Bridging signals

Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 4093    Accepted Submission(s): 2566


 

Problem Description

'Oh no, they've done it again', cries the chief designer at the Waferland chip factory. Once more the routing designers have screwed up completely, making the signals on the chip connecting the ports of two functional blocks cross each other all over the place. At this late stage of the process, it is too
expensive to redo the routing. Instead, the engineers have to bridge the signals, using the third dimension, so that no two signals cross. However, bridging is a complicated operation, and thus it is desirable to bridge as few signals as possible. The call for a computer program that finds the maximum number of signals which may be connected on the silicon surface without rossing each other, is imminent. Bearing in mind that there may be housands of signal ports at the boundary of a functional block, the problem asks quite a lot of the programmer. Are you up to the task?

Figure 1. To the left: The two blocks' ports and their signal mapping (4,2,6,3,1,5). To the right: At most three signals may be routed on the silicon surface without crossing each other. The dashed signals must be bridged. 

A typical situation is schematically depicted in figure 1. The ports of the two functional blocks are numbered from 1 to p, from top to bottom. The signal mapping is described by a permutation of the numbers 1 to p in the form of a list of p unique numbers in the range 1 to p, in which the i:th number pecifies which port on the right side should be connected to the i:th port on the left side.
Two signals cross if and only if the straight lines connecting the two ports of each pair do.

Input

On the first line of the input, there is a single positive integer n, telling the number of test scenarios to follow. Each test scenario begins with a line containing a single positive integer p<40000, the number of ports on the two functional blocks. Then follow p lines, describing the signal mapping: On the i:th line is the port number of the block on the right side which should be connected to the i:th port of the block on the left side.

Output

For each test scenario, output one line containing the maximum number of signals which may be routed on the silicon surface without crossing each other.

Sample Input


6



3
1
5
10
2
3
4
5
6
7
8
9
10
1
8
8
7
6
5
4
3
2
1
9
5
8
9
2
3
1
7
4
6

Sample Output

3 9 1 4

就是求LIS(最长递增子序列);

此题规模到了40000,用O(n^2)的解法会超时。

超时代码:

#include<iostream>
#include<algorithm>
#include<cstring>
#include<iomanip>
#include<vector>
#include<cmath>
#include<stack>
using namespace std;
int main()
{
	int n,a[40010],dp[40010];//dp[i]表示以a[i]结尾的最长子序列的长
	cin>>n;
	while(n--)
	{
		int p;
		cin>>p;
		for(int i=1;i<=p;i++) cin>>a[i];
		memset(dp,0,sizeof(dp));
		int max_len=0;
		for(int i=1;i<=p;i++)
		{
			dp[i]=1;
			for(int j=1;j<i;j++)
			if(a[j]<a[i]) dp[i]=max(dp[i],dp[j]+1);
			max_len=max(max_len,dp[i]);
		}
		cout<<max_len<<endl;
	}
}

因此要用O(log\: n)解法,因为用到了二分搜索,所以出现了log n。

AC代码:

#include<iostream>
#include<algorithm>
#include<cstring>
#include<iomanip>
#include<vector>
#include<cmath>
#include<stack>
using namespace std;
int main()
{
	int n,a[40010],dp[40010];//dp[i]表示长度为i的递增子序列的最小末尾元素
	cin>>n;
	while(n--)
	{
		int p;
		cin>>p;
		for(int i=1;i<=p;i++) cin>>a[i];
		memset(dp,0,sizeof(dp));
		int len=1;
		dp[len]=a[1];
		for(int i=2;i<=p;i++)
		{
			if(a[i]>dp[len]) dp[++len]=a[i];
			else 
			{
				int lb=1,ub=len,mid;
				while(lb<=ub)
				{
					mid=(lb+ub)>>1;
					if(dp[mid]<a[i]) lb=mid+1;
					else ub=mid-1;
				}
				dp[lb]=a[i];
			}
		}
		cout<<len<<endl;
	}
}

还可以借助STL中的lower_bound或upper_bound函数求解。(因为本题中没有重复出现的数所以可以用upper_bound)。

#include<iostream>
#include<algorithm>
#include<cstring>
#include<iomanip>
#include<vector>
#include<cmath>
#include<stack>
using namespace std;
int main()
{
	int n,a[40010];
	vector<int> lis;
	cin>>n;
	while(n--)
	{
		int p;
		cin>>p;
		for(int i=1;i<=p;i++) cin>>a[i];
		lis.clear();
		lis.push_back(a[1]);
		for(int i=2;i<=p;i++)
		{
			if(a[i]>lis.back()) lis.push_back(a[i]);
			else 
			{
				*upper_bound(lis.begin(),lis.end(),a[i])=a[i];
			}
		}
		cout<<lis.size()<<endl;
	}
}

猜你喜欢

转载自blog.csdn.net/qq_40889820/article/details/82080433